<template>
  <ob-form
    :form-data="formData"
    @submit="onSubmitHandler"
    :user-access="{}"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="ФИО "
          v-model="fio"
          :disabled="true"
          property="name"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Телефон "
          v-model="dataSource.phone"
          :disabled="true"
          property="phone"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="E-mail "
          v-model="dataSource.email"
          :disabled="true"
          property="login"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Статус "
          v-model="formData.is_active"
          :items="allowedStatus"
          placeholder
          display-exp="value"
          :is-standart="true"
          value-exp="key"
          property="document_class"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Организация"
          v-model="formData.contractor_title"
          :disabled="true"
          property="name"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Список ролей "
          v-model="selectedRoles"
          :items="items"
          placeholder="Нет"
          display-exp="title"
          :is-dropdown="true"
          :is-multiselect="true"
          property="document_class"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Организации, за которые отвечает сотрудник "
          v-model="selectedOrganisations"
          :items="organisations"
          placeholder="Нет"
          display-exp="title"
          :is-dropdown="true"
          :is-multiselect="true"
          property="document_class"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-date-picker
          label="Дата изменения"
          v-model="formData.updated_at"
          :disabled="true"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import ObForm              from 'common-components/src/obComponents/obForm/index.vue';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObSelect            from 'common-components/src/obComponents/obSelect';
import ObDatePicker        from 'common-components/src/obComponents/obDatePickerConstructor'

export default {
  name: 'UserEdit',
  components: {
    ObForm,
    ObInput,
    ObSelect,
    ObDatePicker
  },
  mixins: [FormValidationMixin],
  props: {
    dataSource: {
      type: Object,
      required: true,
      default: () => {}
    },
    availableRoles: {
      type: Array,
      required: true
    },
    openFrom: {
      type: String
    }
  },
  data() {
    return {
      dataIsChanged: false,
      selectedStatus: this.dataSource.is_active ? 1 : 0,
      selectedRoles: this.dataSource.worker_roles.map(r => r.uuid),
      selectedOrganisations: this.dataSource.organization_user_list.map(o => o.uuid)
    };
  },
  computed: {
    allowedStatus() {
      return [
        { key: false, value: 'Заблокирован' },
        { key: true, value: 'Активен' }
      ];
    },
    fio() {
      return `${this.dataSource.last_name || ''} ${this.dataSource.first_name ||
        ''} ${this.dataSource.patronymic || ''}`;
    },
    items() {
      return [...this.availableRoles, ...this.dataSource.worker_roles];
    },
    organisations() {
      return [...this.dataSource.organization_user_list];
    },
    statusValue() {
      return '';
    }
  },
  watch: {
    dataSource() {
      this.selectedRoles = this.dataSource.worker_roles.map(r => r.uuid);
      this.selectedOrganisations = this.dataSource.organization_user_list.map(o => o.uuid);
      this.selectedStatus = this.dataSource.is_active ? 1 : 0;
    },
    selectedRoles() {
      this.formData.worker_roles = this.selectedRoles.map(r =>
        this.items.find(i => i.uuid === r)
      );
    },
    selectedOrganisations() {
      this.formData.organization_user_list = this.selectedOrganisations.map(o =>
        this.organisations.find(i => i.uuid === o)
      );
    }
  },
  methods: {
    onSubmitHandler() {
      this.$emit('save', this.formData);
    },
    removeListItem(item) {
      this.dataIsChanged = true;
      if (this.selectedRoles) {
        this.selectedRoles = this.selectedRoles.filter(
          elem => elem.key !== item
        );
      } else {
        this.selectedRoles = [];
      }
    },
    close() {
      this.$emit('close');
      this.dataIsChanged = undefined;
    },
    save() {
      this.$emit('save', {
        is_active: this.selectedStatus === 'Активен',
        worker_roles: this.selectedRoles
      });
    },
    onStatusSelect(ev) {
      this.dataIsChanged = true;
      const { selectedItem } = ev;
      if (selectedItem) {
        this.selectedStatus = selectedItem.value;
      }
    },
    onSelect(ev, dataName) {
      if (ev.selectedItem || ev.event) {
        dataName === 'Roles'
          ? (this[`selected${dataName}`] = ev.value)
          : (this[`selected${dataName}`] = ev.selectedItem.value);

        if (!this.dataIsChanged) this.dataIsChanged = true;
      }
    }
  }
};
</script>

<style lang="scss">
.custom-scroll-tag-box {
  .dx-texteditor-input {
    display: none;
  }

  .dx-texteditor.dx-editor-underlined .dx-texteditor-buttons-container {
    height: 50px;
  }

  .custom-text-box {
    .dx-tag {
      margin: 10px 0;
      height: 30px;
      display: flex;
      padding: 0 25px 0 12px;
      align-items: center;
      background: $lavender;
      border-radius: 19px;

      &:last-child {
        margin-bottom: 0;
      }

      p {
        display: flex;
        align-items: center;
        position: relative;
      }

      .delete-item {
        border-radius: 20px;
        position: absolute;
        right: -18px;
        height: 15px;

        &:hover {
          background: gray;
        }
      }

      .dx-template-wrapper {
        margin: 0;
        display: flex;
        align-items: center;
      }
    }
  }
}

.scroll-input {
  .dx-texteditor-container {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
  }
}

/*wrap all classes in popup class*/
.dx-dropdownlist-popup-wrapper.dx-popup-wrapper .dx-overlay-content {
  box-shadow: 0px 4px 8px rgba($color-blue-navy-blue, 0.24);
}

.dx-list-item-content {
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.2px;
}

.select-list-title + .dx-texteditor.dx-editor-underlined .dx-texteditor-input,
.select-list-title
  + .dx-texteditor.dx-editor-underlined
  .dx-placeholder:before {
  padding-top: 24px;
}

.select-list-title {
  font-size: 12px;
  line-height: 12px;
  letter-spacing: 0.4px;
  margin-top: 8px;
  display: block;
  position: absolute;
}

.dx-button-mode-text.dx-state-hover {
  background: $lavender;
}

.dx-button.dx-button-mode-text.dx-state-focused {
  color: $cobalt-blue;
  background: none;
}

.dx-button.dx-button-default.dx-state-disabled {
  background: $color-light-grey;
}

.dx-button.dx-button-default.dx-state-disabled .dx-button-text {
  color: white;
}

.dx-button.dx-button-default.dx-state-focused {
  background: $cobalt-blue;
}

.dx-button.dx-button-default.dx-state-hover {
  background: $color-blue-navy-blue;
  box-shadow: 0px 4px 16px rgba($color-blue-navy-blue, 0.32);
}

.dx-button.dx-button-default {
  background: $color-blue-navy-blue;
  border-radius: 20px;
  cursor: pointer;
}

.dx-checkbox.dx-state-disabled .dx-checkbox-icon {
  border: 1px solid $color-grey-border;
}

.dx-checkbox-checked .dx-checkbox-icon {
  background-color: $color-blue-navy-blue;
}

.dx-checkbox-icon {
  border: 1px solid $color-blue-navy-blue;
}

.dx-checkbox:hover:not(.dx-checkbox-checked) .dx-checkbox-icon {
  background: $lavender;
}

.dx-tag-content {
  background-color: $lavender;
  font-size: 14px;
  line-height: 18px;
  letter-spacing: 0.2px;
  color: $color-text-base;
}

.dx-tag:hover .dx-tag-content {
  background-color: $lavender;
}

.dx-tag-remove-button:before {
  color: $color-grey-span;
  background: none;
}

.dx-dropdowneditor-active {
  border: 1px solid $color-blue-navy-blue;
}

.dx-list:not(.dx-list-select-decorator-enabled)
  .dx-list-item.dx-state-focused.dx-list-item-selected,
.dx-list:not(.dx-list-select-decorator-enabled)
  .dx-list-item.dx-list-item-selected {
  background: $lavender;
}

.dx-list:not(.dx-list-select-decorator-enabled) .dx-list-item.dx-state-active {
  background: $lavender;
}

.dx-dropdowneditor-active .select-menu-icon {
  transform: rotate(180deg);
}

/*select-container*/
.popup-header {
  margin: 0 0 20px 0;
}

.dx-button.dx-state-disabled .dx-button-text {
  color: $allUsersPage-UserEdit-button_text;
}

.check-box-container {
  height: 24px;
  margin-bottom: 10px;
}

.check-box-container .dx-checkbox-text {
  padding-left: 32px;
}

.popup-controls {
  margin-top: auto;
  display: flex;
  justify-content: flex-end;
}

.select-container {
  width: 100%;
  height: 52px;
  margin-bottom: 20px;
  background: $background-white;
  border: 1px solid $color-grey-border;
  border-radius: 3px;
  display: flex;
  align-items: flex-end;
  position: relative;
}

.select-container-unactive {
  margin-bottom: 20px;
  width: 100%;
  height: 52px;
  background: $color-white-lilac;
  border-radius: 3px;
  display: flex;
  align-items: flex-end;
}

.select-container.select-container-tags {
  .custom-scroll-tag-box .custom-text-box .dx-tag {
    margin: 0;
  }
}
.dx-tagbox:not(.dx-texteditor-empty):not(.dx-editor-filled):not(.dx-editor-outlined)
  .dx-texteditor-container {
  margin: 0;
  min-height: 52px;
}
.dx-texteditor-container {
  min-height: 52px;
}
.select-container.select-container-tags
  .custom-scroll-tag-box
  .custom-text-box
  .dx-tag {
  margin: 2px;
}
</style>
